/// PROJECT
#include <csapex/model/node.h>
#include <csapex/model/node_modifier.h>
#include <csapex/msg/io.h>
#include <utils_param/parameter_factory.h>
#include <csapex/utility/register_apex_plugin.h>
#include <csapex/msg/generic_value_message.hpp>

namespace csapex
{
namespace demo
{

class Demo : public csapex::Node
{
public:
    Demo()
    {
    }

    void setupParameters(Parameterizable &parameters)
    {
        parameters.addParameter(param::ParameterFactory::declareBool("B", true));
    }

    void setup(NodeModifier& node_modifier)
    {
        in = node_modifier.addInput<bool>("A");
        out = node_modifier.addOutput<bool>("A || B");
    }

    void process()
    {
        bool a = msg::getValue<bool>(in);
        bool b = readParameter<bool>("B");
        bool result = a || b;

        msg::publish(out, result);
    }

private:
    Input* in;
    Output* out;
};

}
}

CSAPEX_REGISTER_CLASS(csapex::demo::Demo, csapex::Node)

