#ifndef HISTOGRAM_NORMALIZATION_H
#define HISTOGRAM_NORMALIZATION_H

/// PROJECT
#include <csapex/model/node.h>
#include <opencv2/core/core.hpp>

#include <csapex_vision/cv_mat_message.h>
#include <csapex_core_plugins/vector_message.h>
#include <csapex_vision/roi_message.h>


namespace csapex {
class HistogramNormalization : public csapex::Node
{
public:
    HistogramNormalization();
    virtual void process();
   virtual void setup(csapex::NodeModifier& node_modifier) override;

private:
    Output* out_image_;
    Output* out_hist_;
    Input* in_mat_;
    Input* in_mask_;

    void normalize(const cv::Mat &img, const cv::Mat &mask, u_int64_t stamp);
};


}
#endif // HISTOGRAM_NORMALIZATION_H
