#ifndef REGION_FINDER_H
#define REGION_FINDER_H

/// PROJECT
#include <csapex/model/node.h>
#include <opencv2/core/core.hpp>

#include <csapex_vision/cv_mat_message.h>
#include <csapex_core_plugins/vector_message.h>
#include <csapex_vision/roi_message.h>


namespace csapex {
class RegionFinder : public csapex::Node
{
public:
    RegionFinder();
    virtual void process();
   virtual void setup(csapex::NodeModifier& node_modifier) override;

private:
    Output* out_;
    Output* out_debug_;
    Input* in_mat_;

    void findRegion(const cv::Mat &img, cv::Mat &debug, csapex::connection_types::VectorMessage::Ptr out);
};


}

#endif
