/// HEADER
#include <sick14/target_message.h>

/// PROJECT
#include <csapex/utility/assert.h>
#include <csapex/utility/register_msg.h>

CSAPEX_REGISTER_MESSAGE(csapex::connection_types::TargetMessage)

using namespace csapex;
using namespace connection_types;

TargetMessage::TargetMessage(const std::string& frame_id, Message::Stamp stamp)
    : Message (type<TargetMessage>::name(), frame_id, stamp)
{
    detector_type = UNDEFINED;
}

ConnectionType::Ptr TargetMessage::clone() const
{
    Ptr new_msg(new TargetMessage(frame_id, stamp_micro_seconds));
    new_msg->transformation = transformation;
    new_msg->detector_type = detector_type;
    return new_msg;
}

ConnectionType::Ptr TargetMessage::toType() const
{
    return makeEmpty<TargetMessage>();
}


/// YAML
namespace YAML {
Node convert<csapex::connection_types::TargetMessage>::encode(const csapex::connection_types::TargetMessage& rhs)
{
    Node node = convert<csapex::connection_types::Message>::encode(rhs);
    node["transform"] = rhs.transformation; //FIXME !!!!!! transformATION
    node["detector_type"] = (int) rhs.detector_type;
    return node;
}

bool convert<csapex::connection_types::TargetMessage>::decode(const Node& node, csapex::connection_types::TargetMessage& rhs)
{
    if(!node.IsMap()) {
        return false;
    }
    convert<csapex::connection_types::Message>::decode(node, rhs);

    rhs.transformation = node["transformation"].as<TransformMessage>();
    rhs.detector_type  = (TargetMessage::DetectorType) node["detector_type"].as<int>();
    return true;
}
}

