#ifndef NORMALIZATION_HPP
#define NORMALIZATION_HPP
#include <opencv2/core/core.hpp>

namespace utils_cv {
template<typename Tp>
inline void normalizeRelative(cv::Mat &mat)
{
    double min;
    double max;
    cv::minMaxLoc(mat, &min, &max);
    mat = mat - min;
    max -= min;
    mat = mat / max;
    Tp fac = std::numeric_limits<Tp>::max();
    mat = mat * fac;
}

template<typename Tp, typename Sp>
inline void normalizeAbsolute(cv::Mat &mat)
{
    mat = mat * (std::numeric_limits<Sp>::max() / std::numeric_limits<Tp>::max());
}

template<typename Tp>
inline void scale(cv::Mat &mat)
{
    mat = mat * std::numeric_limits<Tp>::max();
}
}

#endif // NORMALIZATION_HPP
